﻿@using System.Web.UI.WebControls;

@using DevExpress.Web.Mvc;
@using DevExpress.Web.Mvc.UI;
@using DevExpress.Utils;

@using Portal.Models.Receiving.KanbanReceivingManifestLevel;
@using Toyota.Common.Web.Html;
@using Toyota.Common.Web.Html.Helper
@using Toyota.Common.Web.MVC;

@Html.DevExpress().GridView(
setting =>
{
    setting.Name = "GridKanbanList";
    setting.KeyFieldName = "KANBAN_ID";
    setting.CallbackRouteValues = new { Controller = "KanbanReceivingManifestLevel", Action = "PartialDataDetail" };
    //setting.ClientSideEvents.Init = "gridDeliveryInvoice_Init";
    //setting.ClientSideEvents.CustomButtonClick = "func";
    //setting.ClientSideEvents.Init = "grid_init";
    setting.ClientSideEvents.BeginCallback = "OnBeginCallbackGridDetail";
    //setting.ClientSideEvents.EndCallback = "OnEndCallbackGrid";
    setting.Styles.Header.HorizontalAlign = HorizontalAlign.Center;
    setting.Width = Unit.Percentage(100);

    setting.Settings.ShowFilterRow = true;
    setting.Settings.ShowFilterRowMenu = true;
    setting.SettingsBehavior.AllowSelectSingleRowOnly = false;
    setting.SettingsBehavior.AllowSelectByRowClick = false;
    setting.CommandColumn.ClearFilterButton.Visible = true;
    setting.CommandColumn.ShowSelectCheckbox = true;
    setting.CommandColumn.Visible = true;
    setting.CommandColumn.Width = Unit.Pixel(20);
    setting.SettingsPager.PageSizeItemSettings.Visible = true;
    setting.SettingsPager.PageSizeItemSettings.Items = new string[] { "10", "30", "50", "100" };
    setting.SettingsPager.PageSizeItemSettings.Caption = "Page size";
    setting.Settings.HorizontalScrollBarMode = ScrollBarMode.Hidden;
    setting.SettingsPager.FirstPageButton.Visible = true;
    setting.SettingsPager.LastPageButton.Visible = true;

    setting.CustomJSProperties = (s, e) =>
    {
        MVCxGridView grid = (MVCxGridView)s;
        int startIndex = grid.PageIndex * grid.SettingsPager.PageSize;
        int end = Math.Min(grid.VisibleRowCount, startIndex + grid.SettingsPager.PageSize);
        //--=== List object
        object[] KANBAN_ID = new object[end - startIndex];
        for (int n = startIndex; n < end; n++)
        {
            KANBAN_ID[n - startIndex] = grid.GetRowValues(n, "KANBAN_ID");

        }
        e.Properties["cpKANBAN_ID"] = KANBAN_ID;
    };
    
    setting.Columns.Add(col =>
    {
        col.FieldName = "KANBAN_ID";
        col.Caption = "Kanban ID";
        col.Width = 50;
        col.CellStyle.HorizontalAlign = System.Web.UI.WebControls.HorizontalAlign.Center;
        col.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
        col.SetDataItemTemplateContent(container =>
        {
            Html.DevExpress().HyperLink(hlSettings =>
            {
                hlSettings.Name = string.Format("hl_{0}", (container as GridViewDataItemTemplateContainer).VisibleIndex);
                hlSettings.NavigateUrl = "javascript:void(0)";
                //hlSettings.Properties.ClientSideEvents.Click = string.Format("function(s, e) {{ openpop('{0}'); }}", (container as GridViewDataItemTemplateContainer).Text);
                hlSettings.Properties.Text = (container as GridViewDataItemTemplateContainer).Text;
            }).Render();
        });
    });

    
    setting.Columns.Add(
        column =>
        {
            column.Caption = "Action";
            //column.Name = "DOCK_CD";
            //column.FieldName = "DOCK_CD";
            column.Width = Unit.Pixel(180);
            column.CellStyle.HorizontalAlign = HorizontalAlign.Center;
            column.Settings.AutoFilterCondition = AutoFilterCondition.Contains;
            column.SetDataItemTemplateContent(c =>
            {
                Html.DevExpress().Button(
                    button =>
                    {
                        button.Name = string.Format("btnReceive[{0}]", (c as GridViewDataItemTemplateContainer).VisibleIndex);
                        button.Text = "Receive";
                        button.Width = Unit.Pixel(150);
                        button.Height = Unit.Pixel(10);
                        button.UseSubmitBehavior = true;
                        button.Style.Add("display", "inline-table");
                        button.ControlStyle.CssClass = "btnOkeh";
                        button.ClientSideEvents.Click = string.Format("function(s,e){{ Receive({0}); }}", (c as GridViewDataItemTemplateContainer).VisibleIndex);

                    }).Render();
            });
        }
    );

}).Bind(Model.GetModel<KanbanReceivingManifestLevelModel>().KanbanReceivingManifestLevelListData).GetHtml()